/**
 *
 * SIROCCO
 * Copyright (C) 2011 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  $Id: LibvirtDriver.java 594 2011-11-02 17:47:11Z dangtran $
 *
 */

package org.ow2.sirocco.vmm.agent.driver.libvirt;

import java.util.Map;

import javax.management.ObjectName;

import org.apache.log4j.Logger;
import org.ow2.sirocco.vmm.agent.domain.ServerPool;
import org.ow2.sirocco.vmm.agent.driver.Driver;

/**
 * Libvirt driver
 */
public class LibvirtDriver implements Driver {
    static Logger logger = Logger.getLogger(LibvirtDriver.class);

    public static String NAME = "libvirt";

    static final String CUSTOMIZE_DISK_SCRIPT = "customizeGuestOS.sh";

    static final String GET_IP_FROM_MAC_SCRIPT = "getIPfromMAC.sh";

    private static String[] attributes = {"sshRootPaswword", "sshPrivateKeyFile", "hypervisor", "syncPeriodMillis"};

    @Override
    public String getName() {
        return LibvirtDriver.NAME;
    }

    public ServerPool newServerPool(final String name, final ObjectName objectName, final Map<String, String> attributes) {
        ServerPool pool = new LibvirtServerPool(name, objectName, attributes);
        return pool;
    }

    @Override
    public String[] getServerPoolCreationAttributes() {
        return LibvirtDriver.attributes;
    }

}
